export default ({ kybTable, toolbarExt }) => {
  const itemsMap = {
    query: {
      slotExt: 'query'
    },
    // filter: { icon: 'filter_list', title: '过滤条件' },
    refresh: {
      icon: 'refresh',
      click: () => kybTable.query(),
      title: '刷新数据'
    },
    import: {
      icon: 'vertical_align_top',
      title: '导入数据',
      click: () => {
        kybTable.importDataWin = true
      }
    },
    export: {
      btnType: 'a',
      href: kybTable.exportUrl,
      target: '_blank',
      icon: 'vertical_align_bottom',
      title: '导出数据',
      click: () => {
        kybTable.importDataWin = true
      }
    },
    showType: {
      type: 'btnMenu',
      icon: 'view_module',
      title: '显示方式',
      items: [
        {
          icon: 'picture_in_picture',
          name: '卡片显示',
          click: v => {
            kybTable.showTypeInner = 'card'
          }
        },
        // {
        //   icon: 'view_list',
        //   name: '网格显示',
        //   click: v => {
        //     kybTable.showTypeInner = 'grad'
        //   }
        // },
        {
          icon: 'view_module',
          name: '表格显示',
          click: v => {
            kybTable.showTypeInner = 'table'
          }
        }
      ]
    },
    save: {
      slotExt: 'save'
    },
    add: {
      slotExt: 'add'
    }
  }

  const toolbarList = []
  if (toolbarExt !== undefined) {
    for (const item of toolbarExt) {
      if (typeof item === 'string') {
        itemsMap[item] && toolbarList.push(itemsMap[item])
      } else if (item.key && itemsMap[item.key]) {
        toolbarList.push(Object.assign({}, itemsMap[item.key], item))
      } else {
        toolbarList.push(item)
      }
    }
  } else {
    Object.keys(itemsMap).forEach(key => {
      toolbarList.push(itemsMap[key])
    })
  }
  return { itemsMap, toolbarList }
}
