/**
 * 树的递归统一方法
 * @param {*} obj
 * @param {*} params
 * @param {*} fn 每次递归的逻辑方法，第一个参数为obj，第二个参数为params，若要跳出递归一定要返回false
 */
let di = (obj, params, fn) => {
  let re = fn(obj, params)
  if (re === false) return false
  if (obj.item && obj.item.children && obj.item.children.length) {
    for (let k in obj.item.children) {
      let child = obj.$refs['item_' + k][0]
      if (child) {
        let re = fn(child, params)
        if (re === false) return false // 如果返回了false 就跳出递归
        di(child, params, fn)
      }
    }
  }
}
export default di
