import { dom } from 'quasar'
// eslint-disable-next-line no-unused-vars
const { css, height, width, offset } = dom

let checkMinAndMax = (x, min, max) => {
  x = (min || min === 0) && x < min ? min : x
  x = (max || max === 0) && x > max ? max : x
  return x
}
let addMark = () => {
  window._bgMarkDialog = document.createElement('div') // 弹出窗的背景
  window._bgMark = document.createElement('div') // 移动和resize的背景
  window._moveMark = document.createElement('div') // 移动和resize的模拟形状
  let styleObjBg = {
    position: 'fixed',
    zIndex: 10000,
    opacity: 0.8,
    backgroundColor: '#000',
    display: 'none',
    top: 0,
    left: 0,
    right: 0,
    bottom: 0
  }
  let styleObj = {
    position: 'fixed',
    zIndex: 10001,
    opacity: 0.25,
    backgroundColor: '#555',
    border: '1px dashed red',
    display: 'none'
  }
  Object.assign(window._moveMark.style, styleObj)
  Object.assign(window._bgMarkDialog.style, styleObjBg)
  styleObjBg.opacity = 0.1
  Object.assign(window._bgMark.style, styleObjBg)

  document.body.appendChild(window._bgMarkDialog)
  document.body.appendChild(window._bgMark)
  document.body.appendChild(window._moveMark)
}
addMark()

let initDocumentMove = () => {
  if (!window._resizeAndMove_init) {
    document.addEventListener('mousemove', $event => {
      let obj = window._move_obj
      // let obj = window._resize_obj
      if (!obj) return
      if (!obj) return
      obj.chaX = $event.clientX - obj.clientX
      obj.chaY = $event.clientY - obj.clientY

      if (obj.type === 'move') {
        // 移动5像素才算移动，否则算点击
        if ((Math.abs(obj.chaX) > 5 || Math.abs(obj.chaY) > 5) && !obj.canMove) {
          if (obj.moveDownEvent) {
            obj.moveDownEvent($event, window._move_obj)
          } else {
            let show = {
              display: 'block',
              left: obj.offsetAll.left + 'px',
              top: obj.offsetAll.top + 'px',
              width: obj.width + 'px',
              height: obj.height + 'px'
            }
            if (getComputedStyle(obj.el)['borderRadius']) {
              Object.assign(show, {
                borderRadius: getComputedStyle(obj.el)['borderRadius']
              })
            }
            Object.assign(window._moveMark.style, show)
            window._bgMark.style.display = 'block'
          }
          obj.canMove = true
        }
        if (!obj.canMove) return
        if (obj.moveType.indexOf('h') > -1) {
          let x = obj.offsetAll.left + obj.chaX
          x = checkMinAndMax(x, obj.minX, obj.maxX)
          obj.chaX = x - obj.offsetAll.left
          css(window._moveMark, { left: `${x}px` })
        }
        if (obj.moveType.indexOf('v') > -1) {
          let y = obj.offsetAll.top + obj.chaY
          y = checkMinAndMax(y, obj.minY, obj.maxY)
          obj.chaY = y - obj.offsetAll.top
          css(window._moveMark, { top: `${y}px` })
        }
      } else if (obj.type === 'resize') {
        if (!obj.canResize) return
        if (obj.resizeType.indexOf('w') > -1 || obj.resizeType.indexOf('e') > -1) {
          let isW = obj.resizeType.indexOf('w') > -1
          let x = obj.width + obj.chaX * (isW ? -1 : 1)
          x = x < 10 ? 10 : x
          obj.chaX = (x - obj.width) * (isW ? -1 : 1)
          if (isW) {
            css(window._moveMark, {
              left: `${obj.offsetAll.left + obj.chaX}px`
            })
          }
          css(window._moveMark, { width: `${x}px` })
        }
        if (obj.resizeType.indexOf('s') > -1 || obj.resizeType.indexOf('n') > -1) {
          let isN = obj.resizeType.indexOf('n') > -1
          let y = obj.height + obj.chaY * (isN ? -1 : 1)
          y = y < 10 ? 10 : y
          obj.chaY = (y - obj.height) * (isN ? -1 : 1)
          if (isN) {
            css(window._moveMark, {
              top: `${obj.offsetAll.top + obj.chaY}px`
            })
          }
          css(window._moveMark, { height: `${y}px` })
        }
      }
      if (obj.type) {
        css(window._moveMark, {
          cursor: getComputedStyle(obj.el)['cursor']
        })
        $event.stopPropagation() // 停止冒泡
        $event.preventDefault() // 停止默认事件
      }
    })
    document.addEventListener('mouseup', $event => {
      let obj = window._move_obj
      if (obj) {
        if (obj.type === 'move' && obj.canMove) {
          if (obj.moveType.indexOf('h') > -1) {
            css(obj.el, { left: `${obj.el.offsetLeft + obj.chaX}px` })
          }
          if (obj.moveType.indexOf('v') > -1) {
            css(obj.el, { top: `${obj.el.offsetTop + obj.chaY}px` })
          }
        } else if (obj.type === 'resize' && obj.canResize) {
          if (obj.resizeType.indexOf('w') > -1 || obj.resizeType.indexOf('e') > -1) {
            let isW = obj.resizeType.indexOf('w') > -1
            let x = obj.width + obj.chaX * (isW ? -1 : 1)
            if (isW) {
              css(obj.el, { left: `${obj.el.offsetLeft + obj.chaX}px` })
            }
            css(obj.el, { width: `${x}px` })
          }
          if (obj.resizeType.indexOf('s') > -1 || obj.resizeType.indexOf('n') > -1) {
            let isN = obj.resizeType.indexOf('n') > -1
            let y = obj.height + obj.chaY * (isN ? -1 : 1)
            if (isN) {
              css(obj.el, { top: `${obj.el.offsetTop + obj.chaY}px` })
            }
            css(obj.el, { height: `${y}px` })
          }
        }
        if (obj.moveDoneEvent) {
          obj.moveDoneEvent($event, obj)
        }
      }
      window._bgMark.style.display = 'none'
      window._moveMark.style.display = 'none'
      window._move_obj = null
    })
    window._resizeAndMove_init = true
  }
}
let findParent = (el, fn, includeSelf) => {
  let p = includeSelf ? el : el.parentElement
  while (p) {
    if (fn(p)) {
      return p
    }
    p = p.parentElement
  }
  return null
}

export default ({ app, Vue }) => {
  // 拖动元素位置
  Vue.directive('move', {
    bind (el) {
      initDocumentMove()
      var att = document.createAttribute('data-move')
      att.value = '1'
      el.setAttributeNode(att)
    },
    // 当被绑定的元素插入到 DOM 中时……
    inserted: function (el, binding) {}
  })
  Vue.directive('resize', {
    bind (el) {
      initDocumentMove()
    },
    // 当被绑定的元素插入到 DOM 中时……
    inserted: function (el, binding) {
      let value = binding.value ? binding.value : {}
      value.moveType || (value.moveType = 'e,s,w,n') // 东南西北
      let ismovebar = el.getAttributeNode('data-move-bar') && el.getAttributeNode('data-move-bar').value === '1'
      let ji = $event => {
        let of = offset(el),
          w = width(el) - 10,
          h = height(el) - 10

        let chaY = $event.clientY - of.top
        let chaX = $event.clientX - of.left
        let c = ''
        if (chaY < 10 && value.moveType.indexOf('n') > -1) {
          c += 'n'
        }
        if (chaY > h && value.moveType.indexOf('s') > -1) {
          c += 's'
        }
        if (chaX < 10 && value.moveType.indexOf('w') > -1) {
          c += 'w'
        }
        if (chaX > w && value.moveType.indexOf('e') > -1) {
          c += 'e'
        }
        window._move_obj || (window._move_obj = {})
        if (c.length) {
          c += '-resize'
          // console.log(c, $event.clientY, of.top)
          window._move_obj.canResize = true
        } else {
          c = ismovebar ? 'move' : 'default'
          if (window._move_obj) {
            window._move_obj.canResize = false
          }
        }
        css(el, { cursor: c })
      }
      el.addEventListener('mousemove', $event => {
        ji($event)
      })
      el.addEventListener('mousedown', $event => {
        // ji($event)
        let c = getComputedStyle(el)['cursor']
        // console.log('cursor', getComputedStyle(el)['cursor'])

        if (!c || c.indexOf('-resize') === -1) return
        let obj = {
          resizeType: c.split('-')[0],
          el: el,
          type: 'resize',
          width: width(el),
          height: height(el),
          offsetAll: offset(el),
          clientX: $event.clientX,
          clientY: $event.clientY,
          canResize: true
        }
        if (getComputedStyle(el)['position'] === 'absolute') {
          let pCon = findParent(el, e => {
            return getComputedStyle(e)['position'] === 'relative'
          })
          if (pCon) {
            obj.pCon = pCon
            let pOffset = offset(pCon)
            obj.minX = pOffset.left
            obj.maxX = pOffset.left + width(pCon) - obj.width
            obj.minY = pOffset.top
            obj.maxY = pOffset.top + height(pCon) - obj.height
          }
        }
        window._move_obj || (window._move_obj = {})
        Object.assign(window._move_obj, obj)
        Object.assign(window._move_obj, value)
        Object.assign(obj.el.style, { transition: 'all 0.2s ease-in' })
        if (value.moveDownEvent) {
          value.moveDownEvent($event, window._move_obj)
        } else {
          let show = {
            display: 'block',
            left: obj.offsetAll.left + 'px',
            top: obj.offsetAll.top + 'px',
            width: obj.width + 'px',
            height: obj.height + 'px'
          }
          Object.assign(window._moveMark.style, show)
          window._bgMark.style.display = 'block'
        }
      })
      // mouseDownDef(el, value, 'resize')
    }
  })
  Vue.directive('moveBar', {
    bind (el) {
      initDocumentMove()
      var att = document.createAttribute('data-move-bar')
      att.value = '1'
      el.setAttributeNode(att)
    },
    // 当被绑定的元素插入到 DOM 中时……
    inserted: function (el, binding) {
      let value = binding.value ? binding.value : {}
      value.moveType || (value.moveType = 'h,v') // h,v
      css(el, { cursor: 'move' })

      el.addEventListener('mousedown', $event => {
        // console.log('el', el.getAttributeNode('data-move').value)
        // console.log('window._move_obj11111', window._move_obj)

        if (window._move_obj && window._move_obj.type === 'resize' && window._move_obj.el === el) return // resize优先级大于移动
        let moveEl = findParent(el, e => e.getAttributeNode('data-move') && e.getAttributeNode('data-move').value === '1', true)
        let obj = {
          el: moveEl,
          width: width(moveEl),
          height: height(moveEl),
          offsetAll: offset(moveEl),
          offset: { top: moveEl.offsetTop, left: moveEl.offsetLeft },
          clientX: $event.clientX,
          clientY: $event.clientY,
          type: 'move'
        }
        Object.assign(obj.el.style, { transition: 'all 0.2s ease-in' })
        Object.assign(obj, value)
        if (getComputedStyle(moveEl)['position'] === 'absolute') {
          let pCon = findParent(moveEl, e => {
            return getComputedStyle(e)['position'] === 'relative'
          })
          if (pCon) {
            obj.pCon = pCon
            let pOffset = offset(pCon)
            obj.minX = pOffset.left
            obj.maxX = pOffset.left + width(pCon) - obj.width
            obj.minY = pOffset.top
            obj.maxY = pOffset.top + height(pCon) - obj.height
          }
        }
        window._move_obj || (window._move_obj = {})
        Object.assign(window._move_obj, obj)
        Object.assign(window._move_obj, value)
      })
    }
  })
}
