import $ from 'jquery'

export default ({ app, Vue }) => {
  Vue.directive('showPhone', {
    // 当被绑定的元素插入到 DOM 中时……
    inserted: function(el, binding) {
      // 聚焦元素
      let v = el.innerHTML
      if (v && v.length === 11) {
        el.innerHTML = `${v.substring(0, 3)} ${v.substring(3, 7)} ${v.substring(7, 11)}`
      }
    }
  })

  Vue.directive('showPhoneMark', {
    // 当被绑定的元素插入到 DOM 中时……
    inserted: function(el, binding) {
      // 聚焦元素
      let isInput = el.tagName.toUpperCase() === 'INPUT'
      let v = isInput ? $(el).val() : $(el).text()
      if (v && v.length === 11) {
        let vv = `${v.substring(0, 3)} **** ${v.substring(7, 11)}`
        if (isInput) $(el).val(vv)
        else $(el).text(vv)
      }
    }
  })

  Vue.directive('focus', {
    // 当被绑定的元素插入到 DOM 中时……
    inserted: function(el, binding) {
      // 聚焦元素
      if (binding.value) {
        el.focus()
        el.select()
      }
    }
  })
}
